//
//  AbstractContentViewController.swift
//  SearchDemo
//
//  Created by Ralf Gronkowski on 13/10/14.
//  Copyright (c) 2014 Ralf Gronkowski. All rights reserved.
//

import UIKit
import MessageUI



class AbstractContentViewController: UIViewController, MFMailComposeViewControllerDelegate {
    
    var thisP4FileRev: P4FileRev!
    let defaultContentInset = UIEdgeInsets(top: 10, left: 0, bottom: 0, right: 0)
    
    convenience init( theP4FileRev: P4FileRev ) {
        self.init()
        
        self.thisP4FileRev = theP4FileRev
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        setupNavigationBar()
        
    }
    
    func setupNavigationBar() {
        let doneBarButtonItem = UIBarButtonItem(barButtonSystemItem: .Done, target: self, action: "doneAction")
        let mailBarButtonItem = UIBarButtonItem(barButtonSystemItem: .Compose, target: self, action: "mailAction")
        navigationItem.rightBarButtonItems = [ doneBarButtonItem, mailBarButtonItem]
    }
    
    
    func doneAction() {
        dismissViewControllerAnimated(true, completion: nil)
    }
    
    func mailAction() {
       
        var mailComposer = MFMailComposeViewController()
        mailComposer.mailComposeDelegate = self
        mailComposer.setSubject("from P4Searcher")
        let swarmURL:NSString = NSUserDefaults.standardUserDefaults().stringForKey(SettingsKeys.swarmURLPreferenceKey)!
        let message = "work on version " + self.thisP4FileRev.rev + " of this in Piper: p4:" + self.thisP4FileRev.file + " or just view the file revision in Swarm: " + swarmURL + "files/" + self.thisP4FileRev.getSwarmURL()
        mailComposer.setMessageBody(message, isHTML: false)
        self.presentViewController(mailComposer, animated: true, completion: nil)
        
    }
    
    func mailComposeController(controller: MFMailComposeViewController!, didFinishWithResult result: MFMailComposeResult, error: NSError!){
        self.dismissViewControllerAnimated(true, completion: nil)
    }
    
}


